USE AdventureWorks
GO

SELECT @@TRANCOUNT;
UPDATE Production.Product
SET Color='Red'
WHERE ProductID=1;
SELECT @@TRANCOUNT;

SET IMPLICIT_TRANSACTIONS ON;
SELECT @@TRANCOUNT;
UPDATE Production.Product
SET Color='Red'
WHERE ProductID=1;
SELECT @@TRANCOUNT;

COMMIT TRAN;
SET IMPLICIT_TRANSACTIONS OFF;

BEGIN TRAN;
SELECT @@TRANCOUNT;

UPDATE Production.Product
SET ListPrice=1
WHERE ProductSubcategoryID=1;
SELECT @@TRANCOUNT;

--SESJA 1
SELECT Name,ListPrice,ProductSubcategoryID
FROM Production.Product
WHERE ProductSubcategoryID<3
ORDER BY ProductSubcategoryID;

--SESJA 2
SELECT Name,ListPrice,ProductSubcategoryID
FROM Production.Product
WHERE ProductSubcategoryID<3
ORDER BY ProductSubcategoryID;

--SESJA 1
ROLLBACK TRAN

SELECT Name,ListPrice,ProductSubcategoryID
FROM Production.Product
WHERE ProductSubcategoryID<3
ORDER BY ProductSubcategoryID;

BEGIN TRAN;
SELECT @@TRANCOUNT;
BEGIN TRAN;
SELECT @@TRANCOUNT;
BEGIN TRAN;
SELECT @@TRANCOUNT;
COMMIT TRAN;
SELECT @@TRANCOUNT;
ROLLBACK TRAN;
SELECT @@TRANCOUNT;

BEGIN TRAN;
INSERT INTO HumanResources.Department (Name, GroupName)
VALUES ('TEST1', 'G1');
SAVE TRAN PP1;
INSERT INTO HumanResources.Department (Name, GroupName)
VALUES ('TEST2', 'G1');
SELECT @@TRANCOUNT;
ROLLBACK TRAN PP1;
SELECT @@TRANCOUNT;

COMMIT TRAN;
SELECT *
FROM HumanResources.Department 
WHERE Name LIKE 'TEST_';


--SESJA 1
BEGIN TRAN;
UPDATE HumanResources.Department
SET Name = UPPER(Name)
WHERE DepartmentID>5;

--SESJA 2
BEGIN TRAN;
UPDATE Production.Product
SET Name = UPPER(Name)
WHERE ProductID >300;

--SESJA 1
SELECT *
FROM Production.Product;

--SESJA 2
SELECT *
FROM HumanResources.Department;

--SESJA 1
SELECT @@TRANCOUNT;

--SESJA 2
ROLLBACK TRAN

--SESJA 1
BEGIN TRAN;
UPDATE HumanResources.Department
SET Name = 'ZmianaWToku'
WHERE DepartmentID=5;


--SESJA 2
SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED;
SELECT Name
FROM HumanResources.Department
WHERE DepartmentID = 5;

--SESJA 1
ROLLBACK

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;
BEGIN TRAN;
SELECT Name
FROM HumanResources.Department
WHERE DepartmentID = 5;

--SESJA 2
SET TRANSACTION ISOLATION LEVEL READ COMMITTED;
UPDATE HumanResources.Department
SET Name = 'OdczytWToku'
WHERE DepartmentID=5;


--SESJA 1
SELECT Name
FROM HumanResources.Department
WHERE DepartmentID = 5;
COMMIT TRAN;

SET TRANSACTION ISOLATION LEVEL REPEATABLE READ;
BEGIN TRAN;
SELECT Name
FROM Production.Product
WHERE ListPrice BETWEEN 10 AND 15;


--SESJA 2
UPDATE Production.Product
SET ListPrice = 12
WHERE ProductID =2;

--SESJA 1
SELECT Name
FROM Production.Product
WHERE ListPrice BETWEEN 10 AND 15;

--SESJA 2
UPDATE Production.Product
SET ListPrice = 8
WHERE Name = 'Taillights - Battery-Powered';

--SESJA 1
COMMIT TRAN

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;
BEGIN TRAN;
SELECT ProductID, Name
FROM Production.Product
WHERE ListPrice BETWEEN 10 AND 15;

--SESJA 2
UPDATE Production.Product
SET ListPrice = 120
WHERE ProductID =3;

--ZAKONCZ SESJE 1 i 2

USE master;
ALTER DATABASE AdventureWorks
SET READ_COMMITTED_SNAPSHOT ON
WITH ROLLBACK IMMEDIATE;

--SESJA 1
USE AdventureWorks;
BEGIN TRAN;
UPDATE HumanResources.Employee 
SET Title = 'X'
WHERE EmployeeID <3;

--SESJA 2
SELECT EmployeeID, Title
FROM HumanResources.Employee
WHERE EmployeeID <5;

--SESJA 1
ROLLBACK
USE master;
ALTER DATABASE AdventureWorks
SET READ_COMMITTED_SNAPSHOT OFF
WITH ROLLBACK IMMEDIATE;
